<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="UTF-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Document</title>
</head>
<body>;
<p>The term <a href="https://cdb.reacttraining.com/use-a-render-prop-50de598f11ce">“render prop”</a> refers to a technique for sharing code between React components using a prop whose value is a function.</p>
<p>A component with a render prop takes a function that returns a React element and calls it instead of implementing its own render logic.</p>
<pre class="jsx"><code>&lt;DataProvider render={data =&gt; (
  &lt;h1&gt;Hello {data.target}&lt;/h1&gt;
)}/&gt;</code></pre>
<p>Libraries that use render props include <a href="https://reacttraining.com/react-router/web/api/Route/render-func">React Router</a>, <a href="https://github.com/paypal/downshift">Downshift</a> and <a href="https://github.com/jaredpalmer/formik">Formik</a>.</p>
<p>In this document, we’ll discuss why render props are useful, and how to write your own.</p>
<h2 id="use-render-props-for-cross-cutting-concerns">Use Render Props for Cross-Cutting Concerns</h2>
<p>Components are the primary unit of code reuse in React, but it’s not always obvious how to share the state or behavior that one component encapsulates to other components that need that same state.</p>
<p>For example, the following component tracks the mouse position in a web app:</p>
<div class="sourceCode" id="cb2"><pre class="sourceCode js"><code class="sourceCode javascript"><a class="sourceLine" id="cb2-1" title="1"><span class="kw">class</span> MouseTracker <span class="kw">extends</span> <span class="va">React</span>.<span class="at">Component</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb2-2" title="2">  <span class="at">constructor</span>(props) <span class="op">{</span></a>
<a class="sourceLine" id="cb2-3" title="3">    <span class="kw">super</span>(props)<span class="op">;</span></a>
<a class="sourceLine" id="cb2-4" title="4">    <span class="kw">this</span>.<span class="at">handleMouseMove</span> <span class="op">=</span> <span class="kw">this</span>.<span class="va">handleMouseMove</span>.<span class="at">bind</span>(<span class="kw">this</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb2-5" title="5">    <span class="kw">this</span>.<span class="at">state</span> <span class="op">=</span> <span class="op">{</span> <span class="dt">x</span><span class="op">:</span> <span class="dv">0</span><span class="op">,</span> <span class="dt">y</span><span class="op">:</span> <span class="dv">0</span> <span class="op">};</span></a>
<a class="sourceLine" id="cb2-6" title="6">  <span class="op">}</span></a>
<a class="sourceLine" id="cb2-7" title="7"></a>
<a class="sourceLine" id="cb2-8" title="8">  <span class="at">handleMouseMove</span>(event) <span class="op">{</span></a>
<a class="sourceLine" id="cb2-9" title="9">    <span class="kw">this</span>.<span class="at">setState</span>(<span class="op">{</span></a>
<a class="sourceLine" id="cb2-10" title="10">      <span class="dt">x</span><span class="op">:</span> <span class="va">event</span>.<span class="at">clientX</span><span class="op">,</span></a>
<a class="sourceLine" id="cb2-11" title="11">      <span class="dt">y</span><span class="op">:</span> <span class="va">event</span>.<span class="at">clientY</span></a>
<a class="sourceLine" id="cb2-12" title="12">    <span class="op">}</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb2-13" title="13">  <span class="op">}</span></a>
<a class="sourceLine" id="cb2-14" title="14"></a>
<a class="sourceLine" id="cb2-15" title="15">  <span class="at">render</span>() <span class="op">{</span></a>
<a class="sourceLine" id="cb2-16" title="16">    <span class="cf">return</span> (</a>
<a class="sourceLine" id="cb2-17" title="17">      <span class="op">&lt;</span>div style<span class="op">={{</span> <span class="dt">height</span><span class="op">:</span> <span class="st">&#39;100vh&#39;</span> <span class="op">}}</span> onMouseMove<span class="op">={</span><span class="kw">this</span>.<span class="at">handleMouseMove</span><span class="op">}&gt;</span></a>
<a class="sourceLine" id="cb2-18" title="18">        <span class="op">&lt;</span>h1<span class="op">&gt;</span>Move the mouse around<span class="op">!</span>&lt;/h1<span class="op">&gt;</span></a>
<a class="sourceLine" id="cb2-19" title="19">        <span class="op">&lt;</span>p<span class="op">&gt;</span>The current mouse position <span class="at">is</span> (<span class="op">{</span><span class="kw">this</span>.<span class="va">state</span>.<span class="at">x</span><span class="op">},</span> <span class="op">{</span><span class="kw">this</span>.<span class="va">state</span>.<span class="at">y</span><span class="op">}</span>)&lt;/p<span class="op">&gt;</span></a>
<a class="sourceLine" id="cb2-20" title="20">      &lt;/div<span class="op">&gt;</span></a>
<a class="sourceLine" id="cb2-21" title="21">    )<span class="op">;</span></a>
<a class="sourceLine" id="cb2-22" title="22">  <span class="op">}</span></a>
<a class="sourceLine" id="cb2-23" title="23"><span class="op">}</span></a></code></pre></div>
<p>As the cursor moves around the screen, the component displays its (x, y) coordinates in a <code>&lt;p&gt;</code>.</p>
<p>Now the question is: How can we reuse this behavior in another component? In other words, if another component needs to know about the cursor position, can we encapsulate that behavior so that we can easily share it with that component?</p>
<p>Since components are the basic unit of code reuse in React, let’s try refactoring the code a bit to use a <code>&lt;Mouse&gt;</code> component that encapsulates the behavior we need to reuse elsewhere.</p>
<div class="sourceCode" id="cb3"><pre class="sourceCode js"><code class="sourceCode javascript"><a class="sourceLine" id="cb3-1" title="1"><span class="co">// The &lt;Mouse&gt; component encapsulates the behavior we need...</span></a>
<a class="sourceLine" id="cb3-2" title="2"><span class="kw">class</span> Mouse <span class="kw">extends</span> <span class="va">React</span>.<span class="at">Component</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb3-3" title="3">  <span class="at">constructor</span>(props) <span class="op">{</span></a>
<a class="sourceLine" id="cb3-4" title="4">    <span class="kw">super</span>(props)<span class="op">;</span></a>
<a class="sourceLine" id="cb3-5" title="5">    <span class="kw">this</span>.<span class="at">handleMouseMove</span> <span class="op">=</span> <span class="kw">this</span>.<span class="va">handleMouseMove</span>.<span class="at">bind</span>(<span class="kw">this</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb3-6" title="6">    <span class="kw">this</span>.<span class="at">state</span> <span class="op">=</span> <span class="op">{</span> <span class="dt">x</span><span class="op">:</span> <span class="dv">0</span><span class="op">,</span> <span class="dt">y</span><span class="op">:</span> <span class="dv">0</span> <span class="op">};</span></a>
<a class="sourceLine" id="cb3-7" title="7">  <span class="op">}</span></a>
<a class="sourceLine" id="cb3-8" title="8"></a>
<a class="sourceLine" id="cb3-9" title="9">  <span class="at">handleMouseMove</span>(event) <span class="op">{</span></a>
<a class="sourceLine" id="cb3-10" title="10">    <span class="kw">this</span>.<span class="at">setState</span>(<span class="op">{</span></a>
<a class="sourceLine" id="cb3-11" title="11">      <span class="dt">x</span><span class="op">:</span> <span class="va">event</span>.<span class="at">clientX</span><span class="op">,</span></a>
<a class="sourceLine" id="cb3-12" title="12">      <span class="dt">y</span><span class="op">:</span> <span class="va">event</span>.<span class="at">clientY</span></a>
<a class="sourceLine" id="cb3-13" title="13">    <span class="op">}</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb3-14" title="14">  <span class="op">}</span></a>
<a class="sourceLine" id="cb3-15" title="15"></a>
<a class="sourceLine" id="cb3-16" title="16">  <span class="at">render</span>() <span class="op">{</span></a>
<a class="sourceLine" id="cb3-17" title="17">    <span class="cf">return</span> (</a>
<a class="sourceLine" id="cb3-18" title="18">      <span class="op">&lt;</span>div style<span class="op">={{</span> <span class="dt">height</span><span class="op">:</span> <span class="st">&#39;100vh&#39;</span> <span class="op">}}</span> onMouseMove<span class="op">={</span><span class="kw">this</span>.<span class="at">handleMouseMove</span><span class="op">}&gt;</span></a>
<a class="sourceLine" id="cb3-19" title="19"></a>
<a class="sourceLine" id="cb3-20" title="20">        <span class="op">{</span><span class="co">/* ...but how do we render something other than a &lt;p&gt;? */</span><span class="op">}</span></a>
<a class="sourceLine" id="cb3-21" title="21">        <span class="op">&lt;</span>p<span class="op">&gt;</span>The current mouse position <span class="at">is</span> (<span class="op">{</span><span class="kw">this</span>.<span class="va">state</span>.<span class="at">x</span><span class="op">},</span> <span class="op">{</span><span class="kw">this</span>.<span class="va">state</span>.<span class="at">y</span><span class="op">}</span>)&lt;/p<span class="op">&gt;</span></a>
<a class="sourceLine" id="cb3-22" title="22">      &lt;/div<span class="op">&gt;</span></a>
<a class="sourceLine" id="cb3-23" title="23">    )<span class="op">;</span></a>
<a class="sourceLine" id="cb3-24" title="24">  <span class="op">}</span></a>
<a class="sourceLine" id="cb3-25" title="25"><span class="op">}</span></a>
<a class="sourceLine" id="cb3-26" title="26"></a>
<a class="sourceLine" id="cb3-27" title="27"><span class="kw">class</span> MouseTracker <span class="kw">extends</span> <span class="va">React</span>.<span class="at">Component</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb3-28" title="28">  <span class="at">render</span>() <span class="op">{</span></a>
<a class="sourceLine" id="cb3-29" title="29">    <span class="cf">return</span> (</a>
<a class="sourceLine" id="cb3-30" title="30">      <span class="op">&lt;&gt;</span></a>
<a class="sourceLine" id="cb3-31" title="31">        <span class="op">&lt;</span>h1<span class="op">&gt;</span>Move the mouse around<span class="op">!</span>&lt;/h1<span class="op">&gt;</span></a>
<a class="sourceLine" id="cb3-32" title="32">        <span class="op">&lt;</span>Mouse /<span class="op">&gt;</span></a>
<a class="sourceLine" id="cb3-33" title="33">      &lt;/<span class="op">&gt;</span></a>
<a class="sourceLine" id="cb3-34" title="34">    )<span class="op">;</span></a>
<a class="sourceLine" id="cb3-35" title="35">  <span class="op">}</span></a>
<a class="sourceLine" id="cb3-36" title="36"><span class="op">}</span></a></code></pre></div>
<p>Now the <code>&lt;Mouse&gt;</code> component encapsulates all behavior associated with listening for <code>mousemove</code> events and storing the (x, y) position of the cursor, but it’s not yet truly reusable.</p>
<p>For example, let’s say we have a <code>&lt;Cat&gt;</code> component that renders the image of a cat chasing the mouse around the screen. We might use a <code>&lt;Cat mouse={{ x, y }}&gt;</code> prop to tell the component the coordinates of the mouse so it knows where to position the image on the screen.</p>
<p>As a first pass, you might try rendering the <code>&lt;Cat&gt;</code> <em>inside <code>&lt;Mouse&gt;</code>’s <code>render</code> method</em>, like this:</p>
<div class="sourceCode" id="cb4"><pre class="sourceCode js"><code class="sourceCode javascript"><a class="sourceLine" id="cb4-1" title="1"><span class="kw">class</span> Cat <span class="kw">extends</span> <span class="va">React</span>.<span class="at">Component</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb4-2" title="2">  <span class="at">render</span>() <span class="op">{</span></a>
<a class="sourceLine" id="cb4-3" title="3">    <span class="kw">const</span> mouse <span class="op">=</span> <span class="kw">this</span>.<span class="va">props</span>.<span class="at">mouse</span><span class="op">;</span></a>
<a class="sourceLine" id="cb4-4" title="4">    <span class="cf">return</span> (</a>
<a class="sourceLine" id="cb4-5" title="5">      <span class="op">&lt;</span>img src<span class="op">=</span><span class="st">&quot;/cat.jpg&quot;</span> style<span class="op">={{</span> <span class="dt">position</span><span class="op">:</span> <span class="st">&#39;absolute&#39;</span><span class="op">,</span> <span class="dt">left</span><span class="op">:</span> <span class="va">mouse</span>.<span class="at">x</span><span class="op">,</span> <span class="dt">top</span><span class="op">:</span> <span class="va">mouse</span>.<span class="at">y</span> <span class="op">}}</span> /&gt;</a>
<a class="sourceLine" id="cb4-6" title="6">    )<span class="op">;</span></a>
<a class="sourceLine" id="cb4-7" title="7">  <span class="op">}</span></a>
<a class="sourceLine" id="cb4-8" title="8"><span class="op">}</span></a>
<a class="sourceLine" id="cb4-9" title="9"></a>
<a class="sourceLine" id="cb4-10" title="10"><span class="kw">class</span> MouseWithCat <span class="kw">extends</span> <span class="va">React</span>.<span class="at">Component</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb4-11" title="11">  <span class="at">constructor</span>(props) <span class="op">{</span></a>
<a class="sourceLine" id="cb4-12" title="12">    <span class="kw">super</span>(props)<span class="op">;</span></a>
<a class="sourceLine" id="cb4-13" title="13">    <span class="kw">this</span>.<span class="at">handleMouseMove</span> <span class="op">=</span> <span class="kw">this</span>.<span class="va">handleMouseMove</span>.<span class="at">bind</span>(<span class="kw">this</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb4-14" title="14">    <span class="kw">this</span>.<span class="at">state</span> <span class="op">=</span> <span class="op">{</span> <span class="dt">x</span><span class="op">:</span> <span class="dv">0</span><span class="op">,</span> <span class="dt">y</span><span class="op">:</span> <span class="dv">0</span> <span class="op">};</span></a>
<a class="sourceLine" id="cb4-15" title="15">  <span class="op">}</span></a>
<a class="sourceLine" id="cb4-16" title="16"></a>
<a class="sourceLine" id="cb4-17" title="17">  <span class="at">handleMouseMove</span>(event) <span class="op">{</span></a>
<a class="sourceLine" id="cb4-18" title="18">    <span class="kw">this</span>.<span class="at">setState</span>(<span class="op">{</span></a>
<a class="sourceLine" id="cb4-19" title="19">      <span class="dt">x</span><span class="op">:</span> <span class="va">event</span>.<span class="at">clientX</span><span class="op">,</span></a>
<a class="sourceLine" id="cb4-20" title="20">      <span class="dt">y</span><span class="op">:</span> <span class="va">event</span>.<span class="at">clientY</span></a>
<a class="sourceLine" id="cb4-21" title="21">    <span class="op">}</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb4-22" title="22">  <span class="op">}</span></a>
<a class="sourceLine" id="cb4-23" title="23"></a>
<a class="sourceLine" id="cb4-24" title="24">  <span class="at">render</span>() <span class="op">{</span></a>
<a class="sourceLine" id="cb4-25" title="25">    <span class="cf">return</span> (</a>
<a class="sourceLine" id="cb4-26" title="26">      <span class="op">&lt;</span>div style<span class="op">={{</span> <span class="dt">height</span><span class="op">:</span> <span class="st">&#39;100vh&#39;</span> <span class="op">}}</span> onMouseMove<span class="op">={</span><span class="kw">this</span>.<span class="at">handleMouseMove</span><span class="op">}&gt;</span></a>
<a class="sourceLine" id="cb4-27" title="27"></a>
<a class="sourceLine" id="cb4-28" title="28">        <span class="op">{</span><span class="co">/*</span></a>
<a class="sourceLine" id="cb4-29" title="29"><span class="co">          We could just swap out the &lt;p&gt; for a &lt;Cat&gt; here ... but then</span></a>
<a class="sourceLine" id="cb4-30" title="30"><span class="co">          we would need to create a separate &lt;MouseWithSomethingElse&gt;</span></a>
<a class="sourceLine" id="cb4-31" title="31"><span class="co">          component every time we need to use it, so &lt;MouseWithCat&gt;</span></a>
<a class="sourceLine" id="cb4-32" title="32"><span class="co">          isn&#39;t really reusable yet.</span></a>
<a class="sourceLine" id="cb4-33" title="33"><span class="co">        */</span><span class="op">}</span></a>
<a class="sourceLine" id="cb4-34" title="34">        <span class="op">&lt;</span>Cat mouse<span class="op">={</span><span class="kw">this</span>.<span class="at">state</span><span class="op">}</span> /&gt;</a>
<a class="sourceLine" id="cb4-35" title="35">      &lt;/div<span class="op">&gt;</span></a>
<a class="sourceLine" id="cb4-36" title="36">    )<span class="op">;</span></a>
<a class="sourceLine" id="cb4-37" title="37">  <span class="op">}</span></a>
<a class="sourceLine" id="cb4-38" title="38"><span class="op">}</span></a>
<a class="sourceLine" id="cb4-39" title="39"></a>
<a class="sourceLine" id="cb4-40" title="40"><span class="kw">class</span> MouseTracker <span class="kw">extends</span> <span class="va">React</span>.<span class="at">Component</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb4-41" title="41">  <span class="at">render</span>() <span class="op">{</span></a>
<a class="sourceLine" id="cb4-42" title="42">    <span class="cf">return</span> (</a>
<a class="sourceLine" id="cb4-43" title="43">      <span class="op">&lt;</span>div<span class="op">&gt;</span></a>
<a class="sourceLine" id="cb4-44" title="44">        <span class="op">&lt;</span>h1<span class="op">&gt;</span>Move the mouse around<span class="op">!</span>&lt;/h1<span class="op">&gt;</span></a>
<a class="sourceLine" id="cb4-45" title="45">        <span class="op">&lt;</span>MouseWithCat /<span class="op">&gt;</span></a>
<a class="sourceLine" id="cb4-46" title="46">      &lt;/div<span class="op">&gt;</span></a>
<a class="sourceLine" id="cb4-47" title="47">    )<span class="op">;</span></a>
<a class="sourceLine" id="cb4-48" title="48">  <span class="op">}</span></a>
<a class="sourceLine" id="cb4-49" title="49"><span class="op">}</span></a></code></pre></div>
<p>This approach will work for our specific use case, but we haven’t achieved the objective of truly encapsulating the behavior in a reusable way. Now, every time we want the mouse position for a different use case, we have to create a new component (i.e. essentially another <code>&lt;MouseWithCat&gt;</code>) that renders something specifically for that use case.</p>
<p>Here’s where the render prop comes in: Instead of hard-coding a <code>&lt;Cat&gt;</code> inside a <code>&lt;Mouse&gt;</code> component, and effectively changing its rendered output, we can provide <code>&lt;Mouse&gt;</code> with a function prop that it uses to dynamically determine what to render–a render prop.</p>
<div class="sourceCode" id="cb5"><pre class="sourceCode js"><code class="sourceCode javascript"><a class="sourceLine" id="cb5-1" title="1"><span class="kw">class</span> Cat <span class="kw">extends</span> <span class="va">React</span>.<span class="at">Component</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb5-2" title="2">  <span class="at">render</span>() <span class="op">{</span></a>
<a class="sourceLine" id="cb5-3" title="3">    <span class="kw">const</span> mouse <span class="op">=</span> <span class="kw">this</span>.<span class="va">props</span>.<span class="at">mouse</span><span class="op">;</span></a>
<a class="sourceLine" id="cb5-4" title="4">    <span class="cf">return</span> (</a>
<a class="sourceLine" id="cb5-5" title="5">      <span class="op">&lt;</span>img src<span class="op">=</span><span class="st">&quot;/cat.jpg&quot;</span> style<span class="op">={{</span> <span class="dt">position</span><span class="op">:</span> <span class="st">&#39;absolute&#39;</span><span class="op">,</span> <span class="dt">left</span><span class="op">:</span> <span class="va">mouse</span>.<span class="at">x</span><span class="op">,</span> <span class="dt">top</span><span class="op">:</span> <span class="va">mouse</span>.<span class="at">y</span> <span class="op">}}</span> /&gt;</a>
<a class="sourceLine" id="cb5-6" title="6">    )<span class="op">;</span></a>
<a class="sourceLine" id="cb5-7" title="7">  <span class="op">}</span></a>
<a class="sourceLine" id="cb5-8" title="8"><span class="op">}</span></a>
<a class="sourceLine" id="cb5-9" title="9"></a>
<a class="sourceLine" id="cb5-10" title="10"><span class="kw">class</span> Mouse <span class="kw">extends</span> <span class="va">React</span>.<span class="at">Component</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb5-11" title="11">  <span class="at">constructor</span>(props) <span class="op">{</span></a>
<a class="sourceLine" id="cb5-12" title="12">    <span class="kw">super</span>(props)<span class="op">;</span></a>
<a class="sourceLine" id="cb5-13" title="13">    <span class="kw">this</span>.<span class="at">handleMouseMove</span> <span class="op">=</span> <span class="kw">this</span>.<span class="va">handleMouseMove</span>.<span class="at">bind</span>(<span class="kw">this</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb5-14" title="14">    <span class="kw">this</span>.<span class="at">state</span> <span class="op">=</span> <span class="op">{</span> <span class="dt">x</span><span class="op">:</span> <span class="dv">0</span><span class="op">,</span> <span class="dt">y</span><span class="op">:</span> <span class="dv">0</span> <span class="op">};</span></a>
<a class="sourceLine" id="cb5-15" title="15">  <span class="op">}</span></a>
<a class="sourceLine" id="cb5-16" title="16"></a>
<a class="sourceLine" id="cb5-17" title="17">  <span class="at">handleMouseMove</span>(event) <span class="op">{</span></a>
<a class="sourceLine" id="cb5-18" title="18">    <span class="kw">this</span>.<span class="at">setState</span>(<span class="op">{</span></a>
<a class="sourceLine" id="cb5-19" title="19">      <span class="dt">x</span><span class="op">:</span> <span class="va">event</span>.<span class="at">clientX</span><span class="op">,</span></a>
<a class="sourceLine" id="cb5-20" title="20">      <span class="dt">y</span><span class="op">:</span> <span class="va">event</span>.<span class="at">clientY</span></a>
<a class="sourceLine" id="cb5-21" title="21">    <span class="op">}</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb5-22" title="22">  <span class="op">}</span></a>
<a class="sourceLine" id="cb5-23" title="23"></a>
<a class="sourceLine" id="cb5-24" title="24">  <span class="at">render</span>() <span class="op">{</span></a>
<a class="sourceLine" id="cb5-25" title="25">    <span class="cf">return</span> (</a>
<a class="sourceLine" id="cb5-26" title="26">      <span class="op">&lt;</span>div style<span class="op">={{</span> <span class="dt">height</span><span class="op">:</span> <span class="st">&#39;100vh&#39;</span> <span class="op">}}</span> onMouseMove<span class="op">={</span><span class="kw">this</span>.<span class="at">handleMouseMove</span><span class="op">}&gt;</span></a>
<a class="sourceLine" id="cb5-27" title="27"></a>
<a class="sourceLine" id="cb5-28" title="28">        <span class="op">{</span><span class="co">/*</span></a>
<a class="sourceLine" id="cb5-29" title="29"><span class="co">          Instead of providing a static representation of what &lt;Mouse&gt; renders,</span></a>
<a class="sourceLine" id="cb5-30" title="30"><span class="co">          use the `render` prop to dynamically determine what to render.</span></a>
<a class="sourceLine" id="cb5-31" title="31"><span class="co">        */</span><span class="op">}</span></a>
<a class="sourceLine" id="cb5-32" title="32">        <span class="op">{</span><span class="kw">this</span>.<span class="va">props</span>.<span class="at">render</span>(<span class="kw">this</span>.<span class="at">state</span>)<span class="op">}</span></a>
<a class="sourceLine" id="cb5-33" title="33">      &lt;/div<span class="op">&gt;</span></a>
<a class="sourceLine" id="cb5-34" title="34">    )<span class="op">;</span></a>
<a class="sourceLine" id="cb5-35" title="35">  <span class="op">}</span></a>
<a class="sourceLine" id="cb5-36" title="36"><span class="op">}</span></a>
<a class="sourceLine" id="cb5-37" title="37"></a>
<a class="sourceLine" id="cb5-38" title="38"><span class="kw">class</span> MouseTracker <span class="kw">extends</span> <span class="va">React</span>.<span class="at">Component</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb5-39" title="39">  <span class="at">render</span>() <span class="op">{</span></a>
<a class="sourceLine" id="cb5-40" title="40">    <span class="cf">return</span> (</a>
<a class="sourceLine" id="cb5-41" title="41">      <span class="op">&lt;</span>div<span class="op">&gt;</span></a>
<a class="sourceLine" id="cb5-42" title="42">        <span class="op">&lt;</span>h1<span class="op">&gt;</span>Move the mouse around<span class="op">!</span>&lt;/h1<span class="op">&gt;</span></a>
<a class="sourceLine" id="cb5-43" title="43">        <span class="op">&lt;</span>Mouse render<span class="op">={</span>mouse <span class="kw">=&gt;</span> (</a>
<a class="sourceLine" id="cb5-44" title="44">          <span class="op">&lt;</span>Cat mouse<span class="op">={</span>mouse<span class="op">}</span> /&gt;</a>
<a class="sourceLine" id="cb5-45" title="45">        )<span class="op">}</span>/&gt;</a>
<a class="sourceLine" id="cb5-46" title="46">      &lt;/div<span class="op">&gt;</span></a>
<a class="sourceLine" id="cb5-47" title="47">    )<span class="op">;</span></a>
<a class="sourceLine" id="cb5-48" title="48">  <span class="op">}</span></a>
<a class="sourceLine" id="cb5-49" title="49"><span class="op">}</span></a></code></pre></div>
<p>Now, instead of effectively cloning the <code>&lt;Mouse&gt;</code> component and hard-coding something else in its <code>render</code> method to solve for a specific use case, we provide a <code>render</code> prop that <code>&lt;Mouse&gt;</code> can use to dynamically determine what it renders.</p>
<p>More concretely, <strong>a render prop is a function prop that a component uses to know what to render.</strong></p>
<p>This technique makes the behavior that we need to share extremely portable. To get that behavior, render a <code>&lt;Mouse&gt;</code> with a <code>render</code> prop that tells it what to render with the current (x, y) of the cursor.</p>
<p>One interesting thing to note about render props is that you can implement most <a href="/docs/higher-order-components.html">higher-order components</a> (HOC) using a regular component with a render prop. For example, if you would prefer to have a <code>withMouse</code> HOC instead of a <code>&lt;Mouse&gt;</code> component, you could easily create one using a regular <code>&lt;Mouse&gt;</code> with a render prop:</p>
<div class="sourceCode" id="cb6"><pre class="sourceCode js"><code class="sourceCode javascript"><a class="sourceLine" id="cb6-1" title="1"><span class="co">// If you really want a HOC for some reason, you can easily</span></a>
<a class="sourceLine" id="cb6-2" title="2"><span class="co">// create one using a regular component with a render prop!</span></a>
<a class="sourceLine" id="cb6-3" title="3"><span class="kw">function</span> <span class="at">withMouse</span>(Component) <span class="op">{</span></a>
<a class="sourceLine" id="cb6-4" title="4">  <span class="cf">return</span> <span class="kw">class</span> <span class="kw">extends</span> <span class="va">React</span>.<span class="at">Component</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb6-5" title="5">    <span class="at">render</span>() <span class="op">{</span></a>
<a class="sourceLine" id="cb6-6" title="6">      <span class="cf">return</span> (</a>
<a class="sourceLine" id="cb6-7" title="7">        <span class="op">&lt;</span>Mouse render<span class="op">={</span>mouse <span class="kw">=&gt;</span> (</a>
<a class="sourceLine" id="cb6-8" title="8">          <span class="op">&lt;</span>Component <span class="op">{</span>...<span class="va">this</span>.<span class="at">props</span><span class="op">}</span> mouse<span class="op">={</span>mouse<span class="op">}</span> /&gt;</a>
<a class="sourceLine" id="cb6-9" title="9">        )<span class="op">}</span>/&gt;</a>
<a class="sourceLine" id="cb6-10" title="10">      )<span class="op">;</span></a>
<a class="sourceLine" id="cb6-11" title="11">    <span class="op">}</span></a>
<a class="sourceLine" id="cb6-12" title="12">  <span class="op">}</span></a>
<a class="sourceLine" id="cb6-13" title="13"><span class="op">}</span></a></code></pre></div>
<p>So using a render prop makes it possible to use either pattern.</p>
<h2 id="using-props-other-than-render">Using Props Other Than <code>render</code></h2>
<p>It’s important to remember that just because the pattern is called “render props” you don’t <em>have to use a prop named <code>render</code> to use this pattern</em>. In fact, <a href="https://cdb.reacttraining.com/use-a-render-prop-50de598f11ce"><em>any</em> prop that is a function that a component uses to know what to render is technically a “render prop”</a>.</p>
<p>Although the examples above use <code>render</code>, we could just as easily use the <code>children</code> prop!</p>
<div class="sourceCode" id="cb7"><pre class="sourceCode js"><code class="sourceCode javascript"><a class="sourceLine" id="cb7-1" title="1"><span class="op">&lt;</span>Mouse children<span class="op">={</span>mouse <span class="kw">=&gt;</span> (</a>
<a class="sourceLine" id="cb7-2" title="2">  <span class="op">&lt;</span>p<span class="op">&gt;</span>The mouse position is <span class="op">{</span><span class="va">mouse</span>.<span class="at">x</span><span class="op">},</span> <span class="op">{</span><span class="va">mouse</span>.<span class="at">y</span><span class="op">}</span>&lt;/p<span class="op">&gt;</span></a>
<a class="sourceLine" id="cb7-3" title="3">)<span class="op">}</span>/&gt;</a></code></pre></div>
<p>And remember, the <code>children</code> prop doesn’t actually need to be named in the list of “attributes” in your JSX element. Instead, you can put it directly <em>inside</em> the element!</p>
<div class="sourceCode" id="cb8"><pre class="sourceCode js"><code class="sourceCode javascript"><a class="sourceLine" id="cb8-1" title="1"><span class="op">&lt;</span>Mouse<span class="op">&gt;</span></a>
<a class="sourceLine" id="cb8-2" title="2">  <span class="op">{</span>mouse <span class="kw">=&gt;</span> (</a>
<a class="sourceLine" id="cb8-3" title="3">    <span class="op">&lt;</span>p<span class="op">&gt;</span>The mouse position is <span class="op">{</span><span class="va">mouse</span>.<span class="at">x</span><span class="op">},</span> <span class="op">{</span><span class="va">mouse</span>.<span class="at">y</span><span class="op">}</span>&lt;/p<span class="op">&gt;</span></a>
<a class="sourceLine" id="cb8-4" title="4">  )<span class="op">}</span></a>
<a class="sourceLine" id="cb8-5" title="5">&lt;/Mouse<span class="op">&gt;</span></a></code></pre></div>
<p>You’ll see this technique used in the <a href="https://github.com/chenglou/react-motion">react-motion</a> API.</p>
<p>Since this technique is a little unusual, you’ll probably want to explicitly state that <code>children</code> should be a function in your <code>propTypes</code> when designing an API like this.</p>
<div class="sourceCode" id="cb9"><pre class="sourceCode js"><code class="sourceCode javascript"><a class="sourceLine" id="cb9-1" title="1"><span class="va">Mouse</span>.<span class="at">propTypes</span> <span class="op">=</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb9-2" title="2">  <span class="dt">children</span><span class="op">:</span> <span class="va">PropTypes</span>.<span class="va">func</span>.<span class="at">isRequired</span></a>
<a class="sourceLine" id="cb9-3" title="3"><span class="op">};</span></a></code></pre></div>
<h2 id="caveats">Caveats</h2>
<h3 id="be-careful-when-using-render-props-with-reactpurecomponent">Be careful when using Render Props with React.PureComponent</h3>
<p>Using a render prop can negate the advantage that comes from using <a href="/docs/react-api.html#reactpurecomponent"><code>React.PureComponent</code></a> if you create the function inside a <code>render</code> method. This is because the shallow prop comparison will always return <code>false</code> for new props, and each <code>render</code> in this case will generate a new value for the render prop.</p>
<p>For example, continuing with our <code>&lt;Mouse&gt;</code> component from above, if <code>Mouse</code> were to extend <code>React.PureComponent</code> instead of <code>React.Component</code>, our example would look like this:</p>
<div class="sourceCode" id="cb10"><pre class="sourceCode js"><code class="sourceCode javascript"><a class="sourceLine" id="cb10-1" title="1"><span class="kw">class</span> Mouse <span class="kw">extends</span> <span class="va">React</span>.<span class="at">PureComponent</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb10-2" title="2">  <span class="co">// Same implementation as above...</span></a>
<a class="sourceLine" id="cb10-3" title="3"><span class="op">}</span></a>
<a class="sourceLine" id="cb10-4" title="4"></a>
<a class="sourceLine" id="cb10-5" title="5"><span class="kw">class</span> MouseTracker <span class="kw">extends</span> <span class="va">React</span>.<span class="at">Component</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb10-6" title="6">  <span class="at">render</span>() <span class="op">{</span></a>
<a class="sourceLine" id="cb10-7" title="7">    <span class="cf">return</span> (</a>
<a class="sourceLine" id="cb10-8" title="8">      <span class="op">&lt;</span>div<span class="op">&gt;</span></a>
<a class="sourceLine" id="cb10-9" title="9">        <span class="op">&lt;</span>h1<span class="op">&gt;</span>Move the mouse around<span class="op">!</span>&lt;/h1<span class="op">&gt;</span></a>
<a class="sourceLine" id="cb10-10" title="10"></a>
<a class="sourceLine" id="cb10-11" title="11">        <span class="op">{</span><span class="co">/*</span></a>
<a class="sourceLine" id="cb10-12" title="12"><span class="co">          This is bad! The value of the `render` prop will</span></a>
<a class="sourceLine" id="cb10-13" title="13"><span class="co">          be different on each render.</span></a>
<a class="sourceLine" id="cb10-14" title="14"><span class="co">        */</span><span class="op">}</span></a>
<a class="sourceLine" id="cb10-15" title="15">        <span class="op">&lt;</span>Mouse render<span class="op">={</span>mouse <span class="kw">=&gt;</span> (</a>
<a class="sourceLine" id="cb10-16" title="16">          <span class="op">&lt;</span>Cat mouse<span class="op">={</span>mouse<span class="op">}</span> /&gt;</a>
<a class="sourceLine" id="cb10-17" title="17">        )<span class="op">}</span>/&gt;</a>
<a class="sourceLine" id="cb10-18" title="18">      &lt;/div<span class="op">&gt;</span></a>
<a class="sourceLine" id="cb10-19" title="19">    )<span class="op">;</span></a>
<a class="sourceLine" id="cb10-20" title="20">  <span class="op">}</span></a>
<a class="sourceLine" id="cb10-21" title="21"><span class="op">}</span></a></code></pre></div>
<p>In this example, each time <code>&lt;MouseTracker&gt;</code> renders, it generates a new function as the value of the <code>&lt;Mouse render&gt;</code> prop, thus negating the effect of <code>&lt;Mouse&gt;</code> extending <code>React.PureComponent</code> in the first place!</p>
<p>To get around this problem, you can sometimes define the prop as an instance method, like so:</p>
<div class="sourceCode" id="cb11"><pre class="sourceCode js"><code class="sourceCode javascript"><a class="sourceLine" id="cb11-1" title="1"><span class="kw">class</span> MouseTracker <span class="kw">extends</span> <span class="va">React</span>.<span class="at">Component</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb11-2" title="2">  <span class="co">// Defined as an instance method, `this.renderTheCat` always</span></a>
<a class="sourceLine" id="cb11-3" title="3">  <span class="co">// refers to *same* function when we use it in render</span></a>
<a class="sourceLine" id="cb11-4" title="4">  <span class="at">renderTheCat</span>(mouse) <span class="op">{</span></a>
<a class="sourceLine" id="cb11-5" title="5">    <span class="cf">return</span> <span class="op">&lt;</span>Cat mouse<span class="op">={</span>mouse<span class="op">}</span> /&gt;<span class="op">;</span></a>
<a class="sourceLine" id="cb11-6" title="6">  <span class="op">}</span></a>
<a class="sourceLine" id="cb11-7" title="7"></a>
<a class="sourceLine" id="cb11-8" title="8">  <span class="at">render</span>() <span class="op">{</span></a>
<a class="sourceLine" id="cb11-9" title="9">    <span class="cf">return</span> (</a>
<a class="sourceLine" id="cb11-10" title="10">      <span class="op">&lt;</span>div<span class="op">&gt;</span></a>
<a class="sourceLine" id="cb11-11" title="11">        <span class="op">&lt;</span>h1<span class="op">&gt;</span>Move the mouse around<span class="op">!</span>&lt;/h1<span class="op">&gt;</span></a>
<a class="sourceLine" id="cb11-12" title="12">        <span class="op">&lt;</span>Mouse render<span class="op">={</span><span class="kw">this</span>.<span class="at">renderTheCat</span><span class="op">}</span> /&gt;</a>
<a class="sourceLine" id="cb11-13" title="13">      &lt;/div<span class="op">&gt;</span></a>
<a class="sourceLine" id="cb11-14" title="14">    )<span class="op">;</span></a>
<a class="sourceLine" id="cb11-15" title="15">  <span class="op">}</span></a>
<a class="sourceLine" id="cb11-16" title="16"><span class="op">}</span></a></code></pre></div>
<p>In cases where you cannot define the prop statically (e.g. because you need to close over the component’s props and/or state) <code>&lt;Mouse&gt;</code> should extend <code>React.Component</code> instead.</p>
</body></html>
